package tango;

import java.util.*;


class AlarmEntry
{
  AlarmEntry(long time,AlarmListener a,AlarmEvent av)
    {
      this.time=time;
      this.a=a;
      this.av=av;
    }
  long 		time;
  AlarmListener a;
  AlarmEvent    av;
}

public class Alarm implements Runnable
{
  Thread th;
  boolean running;
  public static Alarm alarmInstance=new Alarm();
  Vector v;
  AlarmEntry next;
  private Alarm()
    {
      v=new Vector();
      next=null;
      running=true;
      th=new Thread(this);
      th.start();
    }

  synchronized public void add(long time, AlarmListener a,AlarmEvent av)
    {
      AlarmEntry ae=new AlarmEntry(time,a,av);
      v.addElement(ae);
      notify();
    }

  synchronized public void remove(AlarmListener a)
    {
      Vector nv=new Vector();
      for(int i=0;i<v.size();i++)
	if(!((AlarmEntry)v.elementAt(i)).a.equals(a))
	  nv.addElement(v.elementAt(i));
      v=nv;
      if(next!=null && next.a.equals(a)) next=null;
      notify();
    }

  synchronized public void remove(AlarmListener a, AlarmEvent av)
    {
      Vector nv=new Vector();
      for(int i=0;i<v.size();i++)
	{
	  AlarmEntry ae=(AlarmEntry)v.elementAt(i);
	  if(!ae.a.equals(a) || !ae.av.equals(av))
	    nv.addElement(v.elementAt(i));
	}
      v=nv;
      if(next!=null && next.a.equals(a) && next.av.equals(av)) next=null;
      notify();
    }

  synchronized public long getTime()
    {
      return System.currentTimeMillis();
    }

  synchronized public void run()
    {
      while(running)
	{
	  try
	    {
	      next=null;
	      for(int i=0;i<v.size();i++)
		{
		  AlarmEntry ae=(AlarmEntry)v.elementAt(i);
		  if(next==null || ae.time<next.time) next=ae;
		}
	      if(next==null)
		wait();
	      else
		{
		  long t=next.time-getTime();
		  if(t>0) wait(t);
		}
	      if(next!=null && next.time<getTime())
		{
		  v.removeElement(next);
		  next.a.processAlarm(next.av);
		}
	    }
	  catch(Exception e)
	    {
	      e.printStackTrace();
	    }
	}
    }

  synchronized public void dispose()
    {
      running=false;
      next=null;
      notify();
    }
}
